﻿<a href="https://git.io/liblava"><img align="left" src="https://github.com/liblava.png" width="200" style="margin:0px 40px 0px 0px"></a>

🌋 **[liblava](https://git.io/liblava) &nbsp; A modern and easy-to-use library for the <a href="https://www.khronos.org/vulkan/" target="_blank">Vulkan</a>® API**

**lava** is a lean framework that provides **essentials** for **low-level graphics**<br />and is specially well suited for **prototyping**, **tooling** and **education**

<br />

**C++20** &nbsp; + &nbsp; **Modular** &nbsp; / &nbsp; **Windows** &nbsp; + &nbsp; **Linux**

[![Version](https://img.shields.io/badge/Version-0.6.0-blue)](https://git.io/liblava) [![License](https://img.shields.io/github/license/liblava/liblava)](LICENSE) [![CodeFactor](https://www.codefactor.io/repository/github/liblava/liblava/badge)](https://www.codefactor.io/repository/github/liblava/liblava) [![Discord](https://img.shields.io/discord/439508141722435595)](https://discord.lava-block.com) [![Donate](https://img.shields.io/badge/Donate-PayPal-green.svg)](https://paypal.me/liblava) [![Twitter URL](https://img.shields.io/twitter/url/http/shields.io.svg?style=social&label=Follow)](https://twitter.com/liblava)

<br />

### [Features](DOCS.md/#features)

* written in **modern C++** with latest **Vulkan** support
* **[run loop](DOCS.md/#run-loop)** **abstraction** for **[window](DOCS.md/#window)** and **[input](DOCS.md/#input) handling**
* **plain** **[renderer](DOCS.md/#renderer)** and **[command buffer model](DOCS.md/#command-buffer-model)**
* **[texture](DOCS.md/#texture)** and **[mesh](DOCS.md/#mesh)** **loading** from **virtual [file system](DOCS.md/#file-system)**
* **[GUI](DOCS.md/#gui)** + **[camera](DOCS.md/#camera)** + **[logging](DOCS.md/#logging)** + **utils** and much more

<br />

##### ➜ Download latest **<a href="https://github.com/liblava/liblava/releases">demo</a>** (December 20, 2020)

<br />

<a href="https://www.khronos.org/vulkan/" target="_blank"><img align="right" hspace="20" src="res/Vulkan_170px_Dec16.png" width="300"></a>

### Docs

 [Requirements](DOCS.md/#requirements) &nbsp; **[Tutorial](DOCS.md/#tutorial)** &nbsp; **[Guide](DOCS.md/#guide)** &nbsp; [Tests](DOCS.md/#tests) &nbsp; **[Build](DOCS.md/#build)** &nbsp; **[Install](DOCS.md/#install)** &nbsp;  [Third-Party](DOCS.md/#third-party)

<br />

### [Modules](DOCS.md/#modules)

[![core](https://img.shields.io/badge/lava-core-blue.svg)](liblava/core) [![util](https://img.shields.io/badge/lava-util-blue.svg)](liblava/util) [![file](https://img.shields.io/badge/lava-file-blue.svg)](liblava/file) &nbsp; [![base](https://img.shields.io/badge/lava-base-orange.svg)](liblava/base) [![resource](https://img.shields.io/badge/lava-resource-orange.svg)](liblava/resource) [![asset](https://img.shields.io/badge/lava-asset-orange.svg)](liblava/asset) &nbsp; [![frame](https://img.shields.io/badge/lava-frame-red.svg)](liblava/frame) [![block](https://img.shields.io/badge/lava-block-red.svg)](liblava/block) &nbsp; [![app](https://img.shields.io/badge/lava-app-brightgreen.svg)](liblava/app) [![demo](https://img.shields.io/badge/lava-demo-brightgreen.svg)](liblava-demo)

<br />

### Demos

##### [lava spawn](liblava-demo/spawn.cpp) ➜ uniform buffer camera

<a href="liblava-demo/spawn.cpp">![spawn](res/spawn/screenshot.png)</a>

<br />

##### [lava lamp](liblava-demo/lamp.cpp) ➜ push constants to shader

<a href="liblava-demo/lamp.cpp">![lamp](res/lamp/screenshot.png)</a>

<br />

##### [lava triangle](liblava-demo/triangle.cpp) ➜ classic colored mesh

<a href="liblava-demo/triangle.cpp">![triangle](res/triangle/screenshot.png)</a>

<br />

[![Build status](https://ci.appveyor.com/api/projects/status/gxvjpo73qf637hy3?svg=true)](https://ci.appveyor.com/project/TheLavaBlock/liblava) [![Build Status](https://travis-ci.com/liblava/liblava.svg?branch=master)](https://travis-ci.com/liblava/liblava)

<br />

## Collaborate

You can use the [issue tracker](https://github.com/liblava/liblava/issues) to report any bug or compatibility issue

:heart: Thanks to all **[contributors](https://github.com/liblava/liblava/graphs/contributors)** making **liblava** flow...

<br />

### Support

If you want to contribute, we suggest the following:

1. Fork the [official repository](https://github.com/liblava/liblava/fork)
2. Apply your changes to your fork
3. Submit a [pull request](https://github.com/liblava/liblava/pulls) describing the changes you have made

<br />

## License

<a href="https://opensource.org" target="_blank"><img align="right" width="90" src="http://opensource.org/trademarks/opensource/OSI-Approved-License-100x137.png" style="margin:0px 0px 0px 80px"></a>

**liblava** is licensed under [MIT License](LICENSE.md) which allows you to use the software for any purpose you might like, including commercial and for-profit use!

<br />

However, this library includes several [Third-Party](DOCS.md/#third-party) libraries, which are licensed under their own respective **Open Source** licenses ➜ They all allow static linking with closed source software

**All copies of liblava must include a copy of the MIT License terms and the copyright notice**

##### Vulkan and the Vulkan logo are trademarks of the <a href="http://www.khronos.org" target="_blank">Khronos Group Inc.</a>
##### Copyright (c) 2018-present, <a href="https://lava-block.com">Lava Block OÜ</a> and [contributors](https://github.com/liblava/liblava/graphs/contributors)

<br />

<a href="https://git.io/liblava"><img src="https://github.com/liblava.png" width="50"></a>
